var context=canvas1.getContext('2d');
var key = "";
var word = "";
//var word_data = new Array();
var text_data = new Array();
var q_char = "";
var q_word = "";

var limit_time = 60;
var mtime = 0;
var count = 0;
var count_all = 0;
var now = 0;
var kaisu = 0;
var typeAudio = new Audio("type.mp3");
var misuAudio = new Audio("misu.mp3");
var goalAudio = new Audio("goal.mp3");
var bgmAudio = new Audio("bgm1.mp3");

  

//イベントハンドラ（キーボードが押されたときの処理）
window.onkeydown = function( event ){
    
    //押されたキーの文字を大文字として取得
    key = String.fromCharCode( event.keyCode ).toUpperCase();
    //押されたキーの数をカウント
    count_all++;
  
   //ボリュームON・OFF
    if(event.keyCode == 38) 
    {
        bgmAudio.volume = bgmAudio.volume+1;
    }
    if(event.keyCode == 40) 
    {
        bgmAudio.volume = bgmAudio.volume-1;
    }
    
    
    
    //押されたキーが正しい場合の処理
    if( key == q_char ){
        //タイプ音
        typeAudio.pause;
        typeAudio.currentTime=0;
        typeAudio.play(); 
        
        //一致したのでキーボードの赤色キーを白で上書き
        context.font = "16px 'arial'";
        context.fillStyle = 'white';
        context.fillText( 
            q_char, 
            keybind[q_char.toUpperCase()].x,
            keybind[q_char.toUpperCase()].y
        );
 
        //単語の次の文字か次の単語の１文字目に
        if( char_num < word_data[word_num].length - 1 ){
            //単語の次の文字
            char_num++;
        }else{
            //今の単語の番号を記録
	    word_num_pre = word_num;
            //次の単語を乱数で選ぶ
            word_num = Math.floor( Math.random() * ( word_data.length - 1 ) );
            char_num = 0;
            //乱数で選んだ単語が先の単語と同じなら選び直す
	    while( word_num == word_num_pre ){
                word_num = Math.floor( Math.random() * ( word_data.length - 1 ) );
	    }
            //表示用単語更新
            q_word = word_data[word_num].toUpperCase();
        }
        //次に入力すべき文字を決定
        q_char = word_data[word_num].charAt(char_num).toUpperCase();
        //次に入力すべき文字のキーを赤色に
        context.fillStyle = 'red';
        context.fillText( 
            q_char, 
            keybind[q_char.toUpperCase()].x,
            keybind[q_char.toUpperCase()].y
        );
        //正しく入力された文字数を記録
        count++;
    }else{
        //ミスタイプの時
        misuAudio.pause;
        misuAudio.currentTime=0;
        misuAudio.play(); 
    }
}

//メソッド（キーボードの描画更新）
draw_keyboard = function(){
    //キーボードの画像読み込み
    img = new Image(); img.src = "keyboard.svg"; 
    //キーボードの描画
    img.onload = ( function(){
        //キーボード画像の表示位置
        context.drawImage( img, 10, 200);
        //キーボード文字のフォント設定
        context.font = "16px 'arial'";
        //キーボード文字の色を赤に
        context.fillStyle = 'red';
        //キーボード文字を描画
        //A-Z
        for( i = 0; i < 26; i++ ){
            context.fillText( 
                String.fromCharCode( 65 + i ).toUpperCase(), 
                keybind[String.fromCharCode( 65 + i ).toUpperCase()].x,
                keybind[String.fromCharCode( 65 + i ).toUpperCase()].y
            );
        }
        //A-Zi以外
        context.fillText( 
            String.fromCharCode( 44 ).toUpperCase(), 
            keybind[String.fromCharCode( 44 ).toUpperCase()].x,
            keybind[String.fromCharCode( 44 ).toUpperCase()].y
        );
        context.fillText( 
            String.fromCharCode( 46 ).toUpperCase(), 
            keybind[String.fromCharCode( 46 ).toUpperCase()].x,
            keybind[String.fromCharCode( 46 ).toUpperCase()].y
        );
        //キーボード文字の色を白にし再度描画
        //(タイピング開始後、白を赤で上書きするが、
        // 一度入力したキーとしていないキーに微妙な差が
        // 発生したため、すべて一度入力された状態を作る
        context.fillStyle = 'white';
        for( i = 0; i < 26; i++ ){
            context.fillText( 
                String.fromCharCode( 65 + i ).toUpperCase(), 
                keybind[String.fromCharCode( 65 + i ).toUpperCase()].x,
                keybind[String.fromCharCode( 65 + i ).toUpperCase()].y
            );
        }
        context.fillText( 
            String.fromCharCode( 44 ).toUpperCase(), 
            keybind[String.fromCharCode( 44 ).toUpperCase()].x,
            keybind[String.fromCharCode( 44 ).toUpperCase()].y
        );
        context.fillText( 
            String.fromCharCode( 46 ).toUpperCase(), 
            keybind[String.fromCharCode( 46 ).toUpperCase()].x,
            keybind[String.fromCharCode( 46 ).toUpperCase()].y
        );

        //入力すべき文字を赤色で描画
        context.fillStyle = 'red';
        context.fillText( 
            q_char.toUpperCase(), 
            keybind[q_char.toUpperCase()].x,
            keybind[q_char.toUpperCase()].y
        );
    });
}

//メソッド（タイピング実施中の文字、残り秒数などアニメーションする部分の描画処理）
draw = function(){
    //変化する部分を一度クリア
    context.clearRect( 0, 0, 800, 200 ); 
    //文字の色を黒に
    context.fillStyle = 'Black';
    //フォントサイズ、種類設定
    context.font = "24px 'Arial'";
    //残り秒数内容設定
    text1 = "あと " + ( limit_time - mtime ) + " 秒";
    //残り秒数表示
    context.fillText( text1, 340, 80 ); 
    //フォントサイズ、種類設定
    context.font = "48px 'Arial'";
    //入力文字表示
    //context.fillText( q_char, 400-24, 150 ); 
    
    context.fillStyle = 'gray';
    context.textAlign = "start";
    word_pix1 = context.measureText(word_data[word_num].toUpperCase());
    word_pix2 = context.measureText(word_data[word_num].toUpperCase().substring(0,char_num));
    context.fillText( word_data[word_num].toUpperCase().substring(0,char_num), 400-(word_pix1.width/2), 

170 ); 

    context.fillStyle = 'black';
    context.textAlign = "start";
    context.fillText( word_data[word_num].toUpperCase().slice(char_num), 400-

(word_pix1.width/2)+word_pix2.width, 170 ); 
}

//アニメーション処理requestAnimationFrameの複数ブラウザ対応
var animation = window.requestAnimationFrame || 
                window.webkitRequestAnimationFrame || 
                window.mozRequestAnimationFrame || 
                window.oRequestAnimationFrame || 
                window.msRequestAnimationFrame || 
                function( callback, element){
                  window.setTimeout(callback, 1000 / 60);
                };

//メソッド（アニメーション処理のループ)
loop = function(){
    //現時刻取得
    now = new Date();
    //経過時間
    mtime = Math.floor((now.getTime() - start.getTime())/1000);
    //残り秒数などの表示更新
    draw();
    //Active?
    if( !document.hasFocus() && mtime > 3 ){
        alert("練習に集中しましょう！");
    }

    //タイムアップの処理
    if( mtime >= limit_time ){

        //結果表示
        alert(
            " 結果は\n　"
            + Math.round(1000*(count/mtime))/1000 + "打数/秒\n　正確度は"
            + Math.round(1000*(count/count_all))/10 + "%\nでした\n\n"
            + mtime + "秒間の\n入力文字数は" + count + "\n打数は" + count_all
            + "\nミスは" + ( count_all - count ) + "\n"
        );
        
        //練習回数を数える
        if( count>0 ){
            kaisu++;
        }else{
            kaisu=0;
             bgmAudio.pause(); 
             bgmAudio.src="bgm1.mp3"; 
             bgmAudio.play(); 
             bgmAudio.loop = true;
        }
        
        //練習を5回行った
        if(kaisu == 5){
            alert("練習回数5回達成!!\n初めは正確性を重視してミス回数の減少に専念!");
        }
        
        
        //練習回数を10回行った
         if(kaisu == 10){
            alert("練習回数10回達成!!\n少しタイピングのテンポを上げて入力文字数の増加に挑戦!");
             bgmAudio.pause(); 
             bgmAudio.src="bgm2.mp3"; 
             bgmAudio.play(); 
             bgmAudio.loop = true;
        }
            
        
        
        //練習回数を15回行った
         if(kaisu == 15){
            alert("練習回数15回達成!!\nあともう少し!自己記録の更新を目指そう!");
             bgmAudio.pause(); 
             bgmAudio.src="bgm3.mp3"; 
             bgmAudio.play(); 
             bgmAudio.loop = true;
        }
        
        
        //練習回数を20回行った
         if(kaisu == 20){
            alert("練習回数20回達成!!\nお疲れさまでした!明日も練習頑張りましょう!");
             bgmAudio.pause(); 
             goalAudio.play(); 
        }
        
        
        
        
        
        
     //再挑戦処理
        count = 0;
        count_all = 0;
	//単語データの要素番号を乱数で決める。
        word_num = Math.floor( Math.random() * ( word_data.length - 1 ) );
	//単語の何文字目を入力中か判別する変数
        char_num = 0;

	//単語を取り出しすべて大文字に
        q_word = word_data[word_num].toUpperCase();
	//単語の入力すべき文字を取り出し大文字に
        q_char = word_data[word_num].charAt(char_num).toUpperCase();

        //再度挑戦するかログアウト
alert("StartするにはOKボタンか\nEnterキーを押してください" );

        start = new Date();
        draw_keyboard();
    }
    animation( loop );
}
  
  
//初回のスタート処理


//単語データの要素を乱数で決める。
word_num = Math.floor( Math.random() * ( word_data.length - 1 ) );
//単語の何文字目を入力中か判別する変数
char_num = 0;

//単語を取り出しすべて大文字に
q_word = word_data[word_num].toUpperCase();
//単語の入力すべき文字を取り出し大文字に
q_char = word_data[word_num].charAt(char_num).toUpperCase();

alert("20分集中して練習に取り組みましょう！" );

 
//キーボード描画実行
draw_keyboard();

//時間の計測開始
start = new Date();

//最初のbgm
bgmAudio.play();
// volume = 0
bgmAudio.volume = bgmAudio.volume=0;
bgmAudio.loop = true;


//アニメーション開始
loop();